#ifndef WINDOW_H
#define WINDOW_H

#include <QWindow>
#include <QDebug>
#include <QKeyEvent>
#include <Qt3DStudioRuntime2/Q3DSPresentation>
#include <Qt3DStudioRuntime2/Q3DSSurfaceViewer>
#include <QOpenGLContext>
#include <Qt3DStudioRuntime2/Q3DSViewerSettings>

static int page = false;

class Window : public QWindow
{
    Q_OBJECT
public:
    explicit Window(QWindow *parent = nullptr);

    void setPresentation(Q3DSPresentation* presentation)
    {
        if (presentation == nullptr)
        {
            qDebug() << "presentation is null";
            return;
        }
        qDebug() << "Layer visibility is false";
        m_presentation = presentation;
        //m_presentation->setDataInputValue("LayerVisibility", false);
    }

protected:
    virtual void keyPressEvent(QKeyEvent *event)
    {
        if (m_presentation == nullptr)
        {
            qDebug() << "presentation is null";
            return;
        }
        switch(event->key())
        {
        case Qt::Key_1:
            qDebug() << "++--------------------------++ ";
            qDebug() << "||--------------------------||";
            qDebug() << "||--------------------------||";
            qDebug() << "|| Layer visibility is true ||";
            qDebug() << "||--------------------------||";
            qDebug() << "||--------------------------||";
            qDebug() << "++--------------------------++";
            m_presentation->setDataInputValue("LayerVisibility", true);
            break;
        case Qt::Key_2:
            qDebug() << "++---------------------------++";
            qDebug() << "||---------------------------||";
            qDebug() << "||---------------------------||";
            qDebug() << "|| Layer visibility is false ||";
            qDebug() << "||---------------------------||";
            qDebug() << "||---------------------------||";
            qDebug() << "++---------------------------++";
            m_presentation->setDataInputValue("LayerVisibility", false);
            break;
        case Qt::Key_3:
            page = !page;
            qDebug() << page;
            m_presentation->goToSlide("Scene", page);
            break;

        }
    }

private:
    Q3DSPresentation* m_presentation;
    bool m_recVisible;
};

#endif // WINDOW_H
