#include <QGuiApplication>
#include <QWindow>
#include <Qt3DStudioRuntime2/Q3DSViewerSettings>
#include <Qt3DStudioRuntime2/Q3DSPresentation>
#include <Qt3DStudioRuntime2/Q3DSSurfaceViewer>
#include <QOpenGLContext>
#include <QDebug>
#include <QObject>
#include "Window.h"


int main(int argc, char *argv[])
{
    QGuiApplication app(argc, argv);
    QSize size(800, 480);
    Window window;

    window.resize(size);
    window.setSurfaceType(QSurface::OpenGLSurface);
    window.create();
    Q3DSSurfaceViewer viewer;
    QOpenGLContext context;

    context.setFormat(window.format());
    context.create();

    window.connect(&viewer, &Q3DSSurfaceViewer::presentationLoaded, [&window, &viewer]()
    {
        qDebug() << "fdgs";
        window.setPresentation(viewer.presentation());
    });
    viewer.presentation()->setSource(QUrl(QStringLiteral("qrc:/main.uia")));
    viewer.setUpdateInterval(0);
    viewer.settings()->setShowRenderStats(false);
    viewer.settings()->setScaleMode(Q3DSViewerSettings::ScaleModeCenter);
    viewer.create(&window, &context);
//    window.setPresentation(viewer.presentation());


//    connect(&viewer, &Q3DSSurfaceViewer::presentationLoaded, [this](){
//        m_source.setPresentation(m_viewer.presentation());
//    });
    window.show();

    return app.exec();
}
